ROOT-CONFIG(1)

NAME
root-config - ROOT utility for your Makefiles

SYNOPSIS
root-config [options]

DESCRIPTION
Put lines like
    CFLAGS = $(shell root-config --cflags)
    LIBS   = $(shell root-config --libs)
    GLIBS  = $(shell root-config --glibs)
    %Cint.cxx:Include.h LinkDef.h
            rootcint -f $@ -c $^
in you Makefile.

You may also find the automake(1), autoconf(1), and libtool(1) macro file /usr/share/aclocal/root.m4 useful. If that macro file isn't installed where Iaclocal will find it, copy the contents to your local acinclude.m4 file. In the directories you use ROOT libraries, have in your Makefile.am file:
    lib_LTLIBRARIES         = libFoo.la
    pkginclude_HEADERS      = Foo.h
    noinst_HEADERS          = FooCint.h
    libFoo_la_SOURCES       = Foo.cxx FooCint.cxx
    libFoo_la_LDFLAGS       = -version-info 1:0 -R @ROOTLIBDIR@
    libFoo_la_LDADD         = -lCore -lCint @ROOTAUXLIBS@
    BUILT_SOURCES           = FooCint.cxx FooCint.h
    AM_CPPFLAGS             = -I@ROOTINCDIR@
    AM_LDFLAGS              = -L@ROOTLIBDIR@
    CLEANFILES              = *Cint.cxx *Cint.h *~ core
    %Cint.cxx %Cint.h:Include.h LinkDef.h
            @ROOTCINT@ -f $*Cint.cxx -c $(INCLUDES) $(AM_CPPFLAGS) $^
where you should substitute Foo with whatever, and list the appropiate source files in the _SOURCES variable. In you configure.in file, put:
    AC_PROG_CC
    AC_PROG_CXX
    ROOT_PATH
    AM_PROG_LIBTOOL
along with any other macros you may need.

Note that the ROOT_PATH macro takes three optional arguments: the minimal ROOT version to use, action if ROOT is found, and action if ROOT isn't found. Some examples are
    ROOT_PATH(3.03/05, , AC_MSG_ERROR(Your ROOT version is too old))
    ROOT_PATH(, AC_DEFUN(HAVE_ROOT))
For example, if you want to compile some part of your source tree conditionally on wether ROOT is present or not, you can put in your configure.in file
    ROOT_PATH(,
    [
      AC_DEFUN(HAVE_ROOT)
      have_root=yes
    ])
    AM_CONDITIONAL(GOT_ROOT, test "x$have_root" = "xyes")
And then in some Makefile.am
    EXTRA_SOURCES		= root_depenent_source.cc
    if GOT_ROOT
    LIBFOOXTRA              = root_depenent_source.cc
    else
    LIBFOOXTRA              =
    endif
    lib_LTLIBRARIES         = libFoo.la
    libFoo_la_SOURCES	= Foo.cc  $(LIBFOOXTRA)
The full list of substitution variables are:

ROOTCONF
    full path to root-config

ROOTEXEC
    full path to root

ROOTCINT
    full path to rootcint

ROOTLIBDIR
    Where the ROOT libraries are

ROOTINCDIR
    Where the ROOT headers are

ROOTCFLAGS
    Extra compiler flags

ROOTLIBS
    ROOT basic libraries

ROOTGLIBS
    ROOT basic + GUI libraries

ROOTAUXLIBS
    Auxilary libraries and linker flags for ROOT

ROOTAUXCFLAGS
    Auxilary compiler flags

ROOTRPATH
    Same as ROOTLIBDIR

OPTIONS

--help
    Gives a short list of options avaliable, and exit

--version
    Report the version number of installed ROOT, and exit.

--prefix=<prefix>
    If no arguments is given, reports where ROOT is installed. With an argument of =<prefix>, set the base of the subsequent options to <prefix>. If --exec-prefix is passedwith an argument, that argument overrides the argument given to --prefix for the library path.

--exec-prefix=<prefix>
    If no argument is given, report where the libraries are installed. If an argument is given, use that as the installation base directory for the libraries. This option does not affect the include path.

--libdir
    Print the directory where the ROOT libraries are installed.

--incdir
    Print the directory where the ROOT headers are installed.

--libs
    Output a line suitable for linking a program agains the ROOT libraries. No graphics libraries are output.

--glibs
    As above, but also output for the graphics libraries.

--cflags
    Output a line suitable for compiling a source file againd the ROOT header (class declararion) files.

--new
    Put the libNew.so library in the library lists. This option must be given before options --libs and --glibs.

--nonew
    Compatiblity option. Does nothing.

--auxlibs
    Print auxiliary libraries and/or system linker flags.

--noauxlibs
    Do not print auxiliary libraries and/or system linker flags in the output of --libs and --glibs. --auxcflags Print auxiliary compiler flags.

--noauxcflags
    Do not print auxiliary compiler flags in the output of --cflags.

--noldflags
    Do not print library path link option in output of --libs and --glibs.

SEE ALSO
root(1), root-cint(1)

See also the ROOT webpages: http://root.cern.ch

ORIGINAL AUTHORS
The ROOT team (see web page above):
    Rene Brun and Fons Rademakers

COPYRIGHT
ROOT Software Terms and Conditions

The authors hereby grant permission to use, copy, and distribute this software and its documentation for any purpose, provided that existing copyright notices are retained in all copies and that this notice is included verbatim in any distributions. Additionally, the authors grant permission to modify this software and its documentation for any purpose, provided that such modifications are not distributed without the explicit consent of the authors and that existing copyright notices are retained in all copies. Users of the software are asked to feed back problems, benefits, and/or suggestions about the software to the ROOT Development Team (rootdev@root.cern.ch). Support for this software - fixing of bugs, incorporation of new features - is done on a best effort basis. All bug fixes and enhancements will be made available under the same terms and conditions as the original software,

IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT. THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

AUTHOR
This manual page was written by Christian Holm Christensen <cholm@nbi.dk>, for the Debian GNU/Linux system (but may be used by others).